( COPYRIGHT 1986 JOSEPH BARTEL )
( FORTH SCREEN EDITOR )
: CANTOP ." CANNT OPEN FILE" ;
 $CONSTANT NFNDMS STRING NOT FOUND"
: HEDTXT ." LINE:        COLUMN:       HT-FORTH EDITOR" ;

VARIABLE SCRNTOP  VARIABLE CURLIN   VARIABLE CURNUM   VARIABLE LINES
VARIABLE FNDNUM   VARIABLE FNDLIN   VARIABLE FNDFLG
VARIABLE BUFPOS   VARIABLE LINPOS   VARIABLE COLPOS   VARIABLE CURPN 
VARIABLE TEXBUF   VARIABLE NEXTLINE VARIABLE BUFEND
VARIABLE NSAVE    VARIABLE PSAVE    VARIABLE CURSIZ
VARIABLE CHNGFLG  VARIABLE NSFLG    VARIABLE CHX
VARIABLE CHRCNT   VARIABLE DSKBFPN  VARIABLE DSKEOF   VARIABLE OPNCHN
VARIABLE XITFLG   VARIABLE REPTYP   VARIABLE COUNT    VARIABLE MVCNT
VARIABLE INBUF 256 ALLOT   VARIABLE BUFFER 512 ALLOT
VARIABLE SCRSTR 40 ALLOT   VARIABLE RPLSTR  40 ALLOT
VARIABLE FILNAM  40 ALLOT

( DUMMY ROUTINES FOR DEBUG - WILL GET REPLACED )
( REAL SUBROUTINES )
: SPRINT  ( SEND A NUL TERMINATED STRING )
  BEGIN DUP @B DUP 0<> WHILE EMIT 1+ REPEAT 2DROP ;
: MRKCHNG  ( SET CHANGE FLAG )
  TRUE CHNGFLG ! ;
: PLINE ( PRINT CURRENT LINE W/O CRLF )
  CURLIN @ SPRINT ;
: CONTINUE
  ." PRESS * TO CONTINUE >>" KEY 
  3  =  ABORT" PROGRAM TERMINATED" ;
: UPCASE ( CONVERT LOWER CASE TO UPPER CASE )
  DUP  ASCII a ASCII z RANGE IF 32 - ENDIF ;
: SECONDK
  KEY 127 AND UPCASE ;
( ------------- cursor movement ------------- )
( ----- these are for Wyse-30 ------ )
: CLRSCR ( clear screen )
  27 EMIT ASCII ; EMIT ;
: ERASELN  ( erase to end of line )
  27 EMIT ASCII T EMIT ;
: DELCRTCHR ( delete character )
  27 EMIT ASCII W EMIT ;
: DELCRTLIN ( delete line )
  27 EMIT ASCII R EMIT ;
: INSCRTCHR ( insert character )
  27 EMIT ASCII Q EMIT ;
: INSCRTLIN ( insert line )
  27 EMIT ASCII E EMIT ;
: COLCRTLIN ( goto column and line )
  27 EMIT ASCII = EMIT
  31 + EMIT 31 + EMIT ;
: SCROLUP   ( scroll up, new line at bottom )
  1 2 COLCRTLIN  DELCRTLIN
  1 24 COLCRTLIN  ;
: SCROLDN   ( scroll down, new line at top )
  1 2 COLCRTLIN  INSCRTLIN ;
: CURSOF     ( turn off cursor )
  27 EMIT ASCII ` EMIT ASCII 0  EMIT ;
: CURSON     ( turn cursor on block, blink )
  27 EMIT ASCII ` EMIT ASCII 5  EMIT ;
( ---------------------------------------------------------- )
: SETUP ( here - get buffer ready for editing )
  DUP TEXBUF ! DUP CURLIN !
  0 OVER ! 1+ NEXTLINE !
  1 LINES ! 1 CURNUM ! 1 SCRNTOP !
  1 COLPOS ! 2 LINPOS !
  FALSE DUP NSFLG ! XITFLG !
  INBUF 80 + BUFEND !
  INBUF 128 BLANK
  ;                                                            
( ----------------- SUBROUTINES ---------------------------- )
: INSCX  ( INSERT CHAR IN INBUF AT BUFPOS )
  BUFPOS @ DUP 1+  BUFEND @ OVER - 1+ CMOVE>
  ;
: FNDCOLPL ( find colpos given bufpos )
  BUFPOS @ INBUF - 1+ COLPOS !
  ;
: ENTERLIN ( start changes on this line )
  INBUF 128 BLANK
  CURLIN @ INBUF
  BEGIN OVER @B DUP 0<> WHILE
    OVER !B INCDBL REPEAT
  2DROP DROP     FALSE CHNGFLG !
  INBUF COLPOS @ + 1- BUFPOS !
  ;      
: SIZIT  ( ADRS -- SIZE )   
  DUP 0 CHMATCH 1+ SWAP -
  ;
: RE.LINE ( REPLACE LINE IN BUFER )
  INBUF SIZIT COUNT !
  CURLIN @ SIZIT CURSIZ ! 
  COUNT @ CURSIZ @ - ABS MVCNT !
  CURSIZ @ COUNT @ < IF      ( line insert )
    CURLIN @   DUP MVCNT @ +    NEXTLINE @ CURLIN @ - CMOVE>
    NEXTLINE @ MVCNT @ + NEXTLINE !
  ELSE CURSIZ @ COUNT @ > IF  ( line delete )
    CURLIN @ MVCNT @ +   CURLIN @    NEXTLINE @ CURLIN @ - CMOVE
    NEXTLINE @ MVCNT @ - NEXTLINE ! 
  ENDIF ENDIF
  INBUF CURLIN @ COUNT @ CMOVE
  ;
: UP.LINE ( GO UP ONE LINE IN BUFFER )
  CURNUM DECMEM  CURLIN DUP DECMEM
  BEGIN DUP @-B 0= UNTIL INCMEM
  ;
: DO.LINE ( GO DOWN ONE LINE IN BUFFER )
  CURNUM INCMEM          
  CURLIN BEGIN DUP @B+ 0= UNTIL DROP
  ;
: GOTOTOP 1 CURNUM ! TEXBUF @ CURLIN !
  ;
: LOOKUP  ( find line,assume curnum good ) ( num -- pointer )
  DUP FNDNUM !
  CURNUM @ < IF GOTOTOP  ENDIF
  CURLIN @ FNDLIN !
  BEGIN FNDNUM @ CURNUM @ <> WHILE
    FNDLIN @ 0 CHMATCH 1+ FNDLIN !
    FNDNUM DECMEM REPEAT
  FNDLIN @
  ;
: INCLINES ( increment lines and fix pointers )
  LINES INCMEM
  ;
: DECLINES ( decrement lines and fix pointers )
  LINES DECMEM
  ;                                         
( ----------------- generic routines ------------------------- )
: FNDEND  ( used by toeol )
  BEGIN OVER OVER <> WHILE
    DUP @B 32 <> IF 1+ EXIT
    ELSE 1- ENDIF REPEAT
  1+ ;
: LEAVLN  ( LEAVE the line we are on )
  CHNGFLG @ IF
    INBUF BUFEND @ 32 OVER !B FNDEND
    0 OVER !B 2DROP
    RE.LINE ENDIF
  FALSE CHNGFLG !
  ;
: CURSORPL   ( position cursor to colpos, linpos )
  COLPOS @ LINPOS @ COLCRTLIN
  ;
: NEWCOLTXT  ( print new col number and line number)
  37 1 COLCRTLIN   COLPOS @ 2 .R                   
  21 1 COLCRTLIN   CURNUM @ 4 .R
  CURSORPL 
  ;
: NEWHEAD  ( redo heading on screen )
  1 1 COLCRTLIN ERASELN
  15 1 COLCRTLIN  HEDTXT NEWCOLTXT
  ;
: PRNTERR  ( print error message )
  35 1 COLCRTLIN  .$  CONTINUE NEWHEAD
  ;
: NEWSCREEN ( do a new screen display )
  CURLIN @ PSAVE !   CURNUM @ NSAVE !  
  SCRNTOP @ DUP LOOKUP CURLIN ! CURNUM !
  CLRSCR   1 1 COLCRTLIN
  LINES @ CURNUM @ - DUP 23 < NOT IF
    DROP 23  ENDIF COUNT !
  LINES @ 1 = IF CR PLINE
  ELSE COUNT @ 0 DO CR PLINE DO.LINE LOOP
  ENDIF
  NSAVE @ CURNUM !  PSAVE @ CURLIN !
  NEWHEAD
  ;
: GOTOLIN  ( goto a line ) ( linnum -- )
  DUP LOOKUP CURLIN ! CURNUM ! ENTERLIN
  CURNUM @ SCRNTOP @ DUP 22 + RANGE IF
    CURNUM @ SCRNTOP @ - 2+ LINPOS ! NEWCOLTXT
  ELSE CURNUM @ 7 - SCRNTOP !
    9 LINPOS ! NEWSCREEN  ENDIF
  ;
: FINDER  ( FIND SEARCH STRING )
  0 BUFEND @ !B
  SCRSTR 1+ BUFPOS @ $POS DUP 0<> IF
    SCRSTR @B + BUFPOS !
    FNDCOLPL TRUE FNDFLG ! EXIT
  ELSE DROP ENDIF
  CURNUM @ LINES @ = IF FALSE FNDFLG !
    NFNDMS PRNTERR  EXIT ENDIF
  LEAVLN
  CURNUM @ NSAVE !  CURLIN @ PSAVE !
  BEGIN CURNUM @ LINES @ <> WHILE  DO.LINE
    SCRSTR 1+ CURLIN @ $POS DUP 0<> IF
      SCRSTR @B +  CURLIN @ - 1+
      COLPOS ! CURNUM @ GOTOLIN TRUE FNDFLG ! EXIT
    ELSE DROP ENDIF REPEAT
  NSAVE @ CURNUM ! PSAVE @ CURLIN ! ENTERLIN
  FALSE FNDFLG ! NFNDMS PRNTERR  
  ;     
: CHANGER  ( CHANGE STRING )
  32 BUFEND @ !B
  SCRSTR @B RPLSTR @B > IF
    BUFEND @ 80 BLANK
    BUFPOS @ DUP SCRSTR @B - RPLSTR @B + 80 CMOVE
  ELSE SCRSTR @B RPLSTR @B < IF
    BUFEND @ DUP RPLSTR @B + SCRSTR @B - 1+
    BUFEND @ BUFPOS @ - 1+ SCRSTR @B + CMOVE>
  ENDIF ENDIF
  RPLSTR 1+ BUFPOS @ SCRSTR @B - RPLSTR @B  CMOVE
  COLPOS @ SCRSTR @B - RPLSTR @B +  COLPOS !
  MRKCHNG  LEAVLN 1 LINPOS @ COLCRTLIN
  ERASELN PLINE CURSORPL  ENTERLIN
  ;
( ****************** IN AND OUT ROUTINES ******************* )
: GSTRING ( DISPLAY PROMPT AND GET STRING )
  1 1 COLCRTLIN  ERASELN .$
  DUP 40 BLANK    DUP 1+ 40 EXPECT
  SPAN @  OVER !B ( MAKE COUNTED )
  SPAN @ + 1+ 0 SWAP !B
  ;
: GETSTR
  SCRSTR $" SEARCH FOR: " GSTRING ;
: GETRPL
  RPLSTR $" REPLACE WITH: "  GSTRING ;
: GETNAM
  FILNAM $" ENTER FILE NAME: " GSTRING ;

: CKILL  (  KILL  SECOND  CHAR )
  1 1 COLCRTLIN ."   "  CURSORPL
  ;
: TEST  ( a b -- true ) ( a b -- a false )
  OVER = IF DROP TRUE ELSE FALSE ENDIF
  ;
( ----------------- primary routines -------------------------)
: QUITER ( ^KD quit editing )
  1 1 COLCRTLIN  ." ** ARE YOU SURE **?"
  KEY UPCASE ASCII Y = IF TRUE XITFLG !
  ELSE NEWHEAD ENDIF
  ;
: PAGETOP  ( NEW TOP OF PAGE )
  DUP LOOKUP CURLIN ! DUP CURNUM !
  SCRNTOP @ - 2+ LINPOS !
  ENTERLIN NEWSCREEN                  
  ;
: PAGEUP     ( ^R page up)
  CURNUM @ 1 = IF EXIT ENDIF
  LEAVLN  SCRNTOP @ 23 - 1 MAX SCRNTOP !
  CURNUM @ 23 -  1 MAX  PAGETOP
  ;
: PAGEDN   ( ^C page dn)
  CURNUM @ LINES @ = IF EXIT ENDIF
  LEAVLN SCRNTOP @ 23 + LINES 23 - MIN  1 MAX SCRNTOP !
  CURNUM @ 23 +  LINES @  MIN  PAGETOP
  ;
: LINEUP     ( ^E line up)
  CURNUM @ 1 = IF EXIT ENDIF
  LEAVLN UP.LINE
  CURNUM @ SCRNTOP @ 1- = IF
    SCROLDN  1  2 DUP LINPOS !  COLCRTLIN
    PLINE  SCRNTOP DECMEM
  ELSE LINPOS DECMEM ENDIF
  ENTERLIN NEWCOLTXT 
  ;
: LINEDN      ( ^X line dn)
  CURNUM @ LINES @ = IF EXIT ENDIF
  LEAVLN DO.LINE
  CURNUM @ SCRNTOP @ 23 + = IF
    SCROLUP SCRNTOP INCMEM PLINE
  ELSE LINPOS INCMEM ENDIF
  ENTERLIN NEWCOLTXT
  ;
: TOSTRTL  ( ^QS move to start of line )
  INBUF BUFPOS ! 1 COLPOS ! NEWCOLTXT
  ;
: CHARRHT     ( ^D right ch)
  COLPOS @ 80 = IF TOSTRTL
  ELSE COLPOS INCMEM BUFPOS INCMEM NEWCOLTXT ENDIF
  ;
: CHARLFT     ( ^S left ch)
  COLPOS @ 1 = IF 80 DUP COLPOS ! INBUF + 1- BUFPOS !
  ELSE BUFPOS DECMEM COLPOS DECMEM ENDIF
  NEWCOLTXT
  ;
: NEWLINE     ( new line )
  INSCX 13 BUFPOS !B+  MRKCHNG  LEAVLN
  CURLIN  BEGIN DUP @B+ 13 = UNTIL 0 OVER !-B INCMEM
  INCLINES CURNUM INCMEM
  ERASELN   1 COLPOS !  ENTERLIN
  LINPOS @ 24 = IF SCROLUP  SCRNTOP INCMEM
  ELSE LINPOS INCMEM CURSORPL INSCRTLIN ENDIF
  PLINE NEWCOLTXT
  ;
: REPEATCMD   ( repeat last find or replace )
  REPTYP @ 1 = IF FINDER NEWHEAD EXIT ENDIF
  REPTYP @ 2 = IF FINDER
    FNDFLG @ IF CHANGER ENDIF NEWHEAD ENDIF
  ;
: DELETECH    ( ^G del chr)
  DELCRTCHR  MRKCHNG
  BUFPOS @ 1+ DUP 1- BUFEND @ BUFPOS @ - CMOVE
  ;
: DELLFT      ( delete to left )
  COLPOS @ 1 = IF EXIT ENDIF
  CHARLFT DELETECH
  ;
: DELLINE     ( ^Y del line)
  CURNUM @ LINES @ = IF EXIT ENDIF
  CURLIN @ PSAVE ! DO.LINE ENTERLIN MRKCHNG
  13 CURLIN !-B
  PSAVE @ CURLIN !  LEAVLN ENTERLIN
  DECLINES CURNUM DECMEM DELCRTLIN
  SCRNTOP @ 22 + LINES @ <= IF
    1 24 COLCRTLIN
    SCRNTOP @ 22 + LOOKUP
    CURLIN @ SWAP CURLIN ! PLINE CURLIN ! ENDIF
  NEWCOLTXT
  ;
: CHAROK      ( simple character )
  COLPOS @ 80 = IF EXIT ENDIF
  INSCX CHX @ DUP BUFPOS !B+ COLPOS INCMEM
  INSCRTCHR EMIT MRKCHNG NEWCOLTXT
  ;
( --------------- quickmenu routines for ^Q items -------------)
: FINDRPL   ( ^QA search and replace )
  GETSTR GETRPL FINDER
  FNDFLG @ IF CHANGER ENDIF
  NEWHEAD  2 REPTYP !
  ;
: ENDOFILE  ( ^QC move to end of file )
  LEAVLN LINES @ GOTOLIN
  ;              
: TOENDLN   ( ^QD move to end of line )
  INBUF 80 -TRAILING 
  ?DUP IF DUP 80 < IF 1+ ENDIF ELSE 1 ENDIF
  TUCK + 1- BUFPOS ! COLPOS ! NEWCOLTXT
  ;
: FINDEX    ( ^QF find string )
  GETSTR FINDER NEWHEAD
  1 REPTYP !
  ;
: RESTORLIN  ( ^QL restore line )
  1 DUP COLPOS ! LINPOS @ COLCRTLIN
  ERASELN  PLINE ENTERLIN
  ;
: TOPOFILE ( ^QR move to top of file )
  LEAVLN   GOTOTOP  1 COLPOS !   2 LINPOS !
  ENTERLIN  1 SCRNTOP !  NEWSCREEN
  ;
: DELENDLN ( ^QY delete to end of line )
  BUFPOS @ 80 BLANK  COLPOS @ LINPOS @ COLCRTLIN ERASELN  MRKCHNG
  ;
( ---------- specialK routines  for ^K items ----------------- )
: FGETC   ( GET A CHAR FROM DISK )
  CHRCNT @ 0= IF 
    BUFFER DSKBFPN !
    OPNCHN @ BUFFER 512 READFIL
    DUP 0= IF 26 DSKBFPN @ ! 1 ENDIF
    CHRCNT !  ENDIF
  CHRCNT DECMEM DSKBFPN @B+
  ;
: READLN  ( READ A LINE FROM THE DISK )
  NEXTLINE @ CURLIN !
  BEGIN FGETC
    DUP 26 = IF TRUE DSKEOF ! DROP 0 ENDIF
    DUP 13 = IF DROP 0 ENDIF
    DUP 10 <> IF DUP NEXTLINE !B+ ENDIF
    0= UNTIL
  ;
: KREAD  ( ^KR read file into buffer )
  GETNAM FILNAM OPENFIL
  DUP 0= IF DROP CANTOP NEWHEAD EXIT
  ELSE OPNCHN ! ENDIF
  FALSE DSKEOF ! 0 CHRCNT ! LEAVLN
  LINES @ 1 = CURLIN @B 0= AND IF
    0 LINES ! TEXBUF @ DUP CURLIN ! NEXTLINE ! ENDIF
  CURNUM @ NSAVE !    CURLIN @ PSAVE !
  BEGIN READLN LINES INCMEM DSKEOF @ UNTIL
  NSAVE @ CURNUM !    PSAVE @ CURLIN !
  OPNCHN @ CLOSFIL DROP NEWSCREEN
  ;                                
: BUFDUMP   ( DUMP OUTPUT BUFFER )
  OPNCHN @ BUFFER CHRCNT @ WRITFIL DROP
  BUFFER DSKBFPN ! 0 CHRCNT !
  ;
: FPUTC    ( SEND CHAR TO DISK )
  CHRCNT @ 512 >= IF BUFDUMP ENDIF
  DSKBFPN !B+ CHRCNT INCMEM
  ;
: SAVLIN   ( SAVE SEND LINE TO DISK )
  CURLIN  BEGIN DUP @B+ DUP 0<> WHILE FPUTC  REPEAT  2DROP
  CURNUM @ LINES @ <> IF 13 FPUTC 10 FPUTC ENDIF
  ;
: KWRITE  ( ^KW write buffer to file )
  GETNAM  FILNAM MAKFIL DROP
  FILNAM OPENFIL DUP 0= IF
  DROP CANTOP CONTINUE NEWHEAD EXIT
  ELSE OPNCHN ! ENDIF
  BUFFER DSKBFPN !   0 CHRCNT !
  CURNUM @ NSAVE !    CURLIN @ PSAVE !
  TEXBUF @ CURLIN !   1 CURNUM !
  LINES @ 0 DO SAVLIN LOOP
  NSAVE @ CURNUM !    PSAVE @ CURLIN !
  NEWHEAD
  26 FPUTC BUFDUMP OPNCHN @ CLOSFIL DROP
  ;
: EHELP ( special help screen ^J )
   LEAVLN  CLRSCR 1 2 COLCRTLIN
    ." ====== HELP SCREEN FOR EDS - K-OS ONE SCREEN EDITOR ======"
CR  ." ------- FOR HELP SCREEN ^J  or lf ----------"
CR  ." ^E - line up             | ^R - page up"
CR  ." ^X - line down           | ^C - page down"
CR  ." ^L - repeat last find    | ^M - new line"
CR  ." ^D - char right          | ^G - del char"
CR  ." ^S - char left           | ^Y - delete line"
CR  ." ----------------------------------------------------------"
CR  ." ^QS - start of line      | ^QL - restore line"
CR  ." ^QD - end of line        | ^QY - delete to end of line"
CR  ." ^QR - top of file        |"
CR  ." ^QC - bottom of file     | ^KR - read file"
CR  ." ^QA - find and replace   | ^KW - write file"
CR  ." ^QF - find               | ^KD - exit editor"
CR  ." ----------------------------------------------------------"
CR  CONTINUE  ENTERLIN NEWSCREEN CURSORPL
  ;
: QUICKMENU ( menu for ^Q items )
1 1 COLCRTLIN ." ^Q"  SECONDK
ASCII A  TEST IF FINDRPL   EXIT ENDIF  ( ^QA search and replace )
ASCII C  TEST IF ENDOFILE  EXIT ENDIF  ( ^QC move to end of file )
ASCII D  TEST IF TOENDLN   EXIT ENDIF  ( ^QD move to end of line )
ASCII F  TEST IF FINDEX    EXIT ENDIF  ( ^QF find string )
ASCII L  TEST IF RESTORLIN EXIT ENDIF  ( ^QL restore line )
ASCII R  TEST IF TOPOFILE  EXIT ENDIF  ( ^QR move to top of file )
ASCII S  TEST IF TOSTRTL   EXIT ENDIF  ( ^QS move to start of line )
ASCII Y  TEST IF DELENDLN  EXIT ENDIF  ( ^QY delete to end of line )
DROP ." INVALID CMD  " CONTINUE NEWHEAD
  ;
: SPECIALK ( menu for ^K items )
1 1 COLCRTLIN ." ^K"  SECONDK
ASCII D  TEST IF QUITER EXIT ENDIF   ( ^KD stop edit )
ASCII R  TEST IF KREAD  EXIT ENDIF   ( ^KR read file into buffer )
ASCII W  TEST IF KWRITE EXIT ENDIF   ( ^KW write buffer to file )
DROP ." INVALID CMD  " CONTINUE NEWHEAD
  ;
: SCREENED  ( main screen edit procedure )
KEY 127 AND DUP CHX !
  4 TEST IF CHARRHT   EXIT ENDIF   ( ^D right ch)
 19 TEST IF CHARLFT   EXIT ENDIF   ( ^S left ch)
  5 TEST IF LINEUP    EXIT ENDIF   ( ^E line up)
 24 TEST IF LINEDN    EXIT ENDIF   ( ^X line dn)
 18 TEST IF PAGEUP    EXIT ENDIF   ( ^R page up)
  3 TEST IF PAGEDN    EXIT ENDIF   ( ^C page dn)
  8 TEST IF DELLFT    EXIT ENDIF   ( ^H del left ch, BS )
 17 TEST IF QUICKMENU CKILL EXIT ENDIF   ( ^Q menu )
 10 TEST IF EHELP     EXIT ENDIF   ( ^J help screen )
 11 TEST IF SPECIALK CKILL EXIT ENDIF    ( ^K menu )
 13 TEST IF NEWLINE   EXIT ENDIF   ( new line )
 12 TEST IF REPEATCMD EXIT ENDIF   ( ^L repeat )
  7 TEST IF DELETECH  EXIT ENDIF   ( ^G del chr)
127 TEST IF DELLFT    EXIT ENDIF   ( delete left )
 25 TEST IF DELLINE   EXIT ENDIF   ( ^Y del line)
DUP 32 126 RANGE IF CHAROK ENDIF DROP
  ;
: EDITIT
  FALSE XITFLG !
  BEGIN SCREENED XITFLG @ UNTIL ;
: EDIT  ( main program )
  HERE 512 + SETUP CLRSCR NEWHEAD
  ENTERLIN  EDITIT  CLRSCR
  ;
( ------------------- END OF EDITOR ----------------- )
VOCABULARY EDITV 
EDITV DEFINITIONS
: EDRX EDIT BYE ;
FORTH DEFINITIONS
QUIT


