( 68000 ASM IN FORTH -- FROM F83 )
( 5-27-87 almost a copy from DDJ - Perry )
( many parts assume F83 is the FORTH host )

VOCABULARY ASSEMBLER
: CODE   32 WORD DROP HEADER ASSEMBLER ; IMMEDIATE
ASSEMBLER DEFINITIONS
: END-CODE
   CURRENT @ CONTEXT ! [ HEX ] 4E75 ,W ;
: C;     END-CODE ;      

( debug comma definitions send code to console )
(
: ,W   BASE @ SWAP HEX <#   # # # #   #> TYPE BASE ! ;
: ,    BASE @ SWAP HEX <#   # # # #   # # # #   #> TYPE BASE ! ;
)                                                               

: ?,L    IF , ELSE ,W ENDIF ;
: SHL    0 DO 2* LOOP ;

( ------------- 68000 META ASSEMBLER ------------ )
OCTAL
VARIABLE SIZE
: BYTE   10000 SIZE ! ;
: WORD   30100 SIZE ! ;  WORD
: LONG   20600 SIZE ! ;
: SZ   SIZE @ AND OR ;
: SZ3   00300 SZ ;    ( instr -- instr )
: SZ4   00400 SZ ;
: SZ300   30000 SZ ;
: ISZ40   10000 AND 2/ OR ;  ( ext mode -- ext )
: LONG?   SIZE @ 20600 = ;
: -SZ1   LONG? IF 100 OR ENDIF ;

( ------------ ADDRESSING MODES ----------------- )
: REGS   10 0 DO 1001 I * OVER OR CONSTANT LOOP DROP ;
0000 REGS D0 D1 D2 D3 D4 D5 D6 D7
0110 REGS A0 A1 A2 A3 A4 A5 A6 A7
: MODE   SWAP 7007 AND OR ;
: )     0220 MODE ;    ( ADRS REG IND )
: )+    0330 MODE ;    ( ADRS REG IND POST-INC )
: -)    0440 MODE ;    ( ADRS REG IND PRE-DEC )
: D)    0550 MODE ;    ( ADRS REG + DISP )
: DI)   0660 MODE ;    ( ADRS REG + DISP + INDEX.W )
: LDI) 10660 MODE ;    ( ADRS REG + DISP + INDEX.L )
0770 CONSTANT  #)      ( IMM ADRS )
1771 CONSTANT  L#)     ( LONG IMM ADRS )
2772 CONSTANT  DPC)    ( PC + DISP )
3773 CONSTANT  DIPC)   ( PC + DISP + INDEX.W )
13773 CONSTANT LDIPC)  ( PC + DISP + INDEX.L )
4774 CONSTANT  #       ( IMM DATA )

( ------------- FIELDS AND REGISTER ARGS ---------- )
: RD   7000 AND ;
: RS   0007 AND ;
: MS   0070 AND ;
: EAS   0077 AND ;
: LOW   0377 AND ;
: DN? ( ea -- ea flag ) DUP MS 0= ;
: SRC ( ea instr -- ea instr ) OVER EAS OR ;
: DST ( ea instr -- instr ) SWAP RD OR ;
A7 CONSTANT SP  ( alias for stack pointer )

( -------------- EXTENDED ADDRESSING --------------- )
: DOUBLE?  ( mode -- flag )
   DUP L#) = SWAP # = LONG? AND OR ;
: INDEX?   ( {n} mode -- {a} mode )
   >R  R@ MS 60 =  R@ EAS 73 =  OR
   IF  DUP RD 3 SHL SWAP MS IF 100000 OR ENDIF
       R@ ISZ40 SWAP LOW OR
   ENDIF R> ;
: MORE?  ( ea -- ea flag )   DUP MS 0040 > ;
: ,MORE  ( ea -- )
   MORE? IF INDEX? DOUBLE? ?,L ELSE DROP ENDIF ;
: IMM?DROP   ( {n} # -- {n} )  DUP 4774 = IF DROP ENDIF ;
        
( -----------  EXTENDED ADDRESSING EXTRA ------------- )
VARIABLE CEXTRA   ( count of extra words )  0 CEXTRA !
VARIABLE EXTRA    ( extra words )

: EXTRA?  ( {n} mode -- mode )
   MORE? IF >R R@ INDEX? DOUBLE?
       IF 2 ELSE 1 ENDIF CEXTRA ! EXTRA ! R>
   ELSE 0 CEXTRA !
   ENDIF ;
: ,EXTRA  ( -- )
   CEXTRA @ ?DUP
   IF EXTRA @ SWAP 1- ?,L   0 CEXTRA !  ENDIF ;

( -------------- IMMEDIATE AND ADRS REG -------------- )
: IMM   ( sea dea instr -- )  
   >R EXTRA? EAS R> OR SZ3 ,W ,MORE ,EXTRA ;
: ORI    0000 IMM ;
: ANDI   1000 IMM ;
: SUBI   2000 IMM ;
: ADDI   3000 IMM ;
: EORI   5000 IMM ;
: CMPI   6000 IMM ;
: IMMSR   ( dea instr -- )   ,W ,MORE ;
: ANDI>SR   001174 IMMSR ;   : ANDI>CCR   001074 IMMSR ;
: EORI>SR   005174 IMMSR ;   : EORI>CCR   005074 IMMSR ;
: ORI>SR    000174 IMMSR ;   : ORI>CCR    000074 IMMSR ;
: IQ   (  sea dea instr -- )
   >R EXTRA? EAS R> OR >R IMM?DROP RS 11 SHL R> OR SZ3 ,W ,EXTRA ;
: ADDQ   050000 IQ ;    : SUBQ   050400 IQ ;
: IEAA   ( sea dea instr -- )   DST SRC SZ4 ,W ,MORE ;
: ADDA   150300 IEAA ;
: CMPA   130300 IEAA ;
: LEA    040700 IEAA ;
: SUBA   110300 IEAA ;

( -------- SHIFTS, ROTATES, AND BITS ----------------- )
: ISR   ( sea dea instr -- )   >R DN?
   IF SWAP DN? IF R> 40 OR >R ELSE DROP SWAP RS 11 SHL ENDIF
      RD SWAP RS OR R> OR 160000 OR SZ3 ,W
   ELSE DUP EAS 300 OR R@ 400 AND OR R> 70 AND 6 SHL OR
      160000 OR ,W ,MORE
   ENDIF ;            
: ASL    400 ISR ;    : ASR    000 ISR ;
: LSL    410 ISR ;    : LSR    010 ISR ;
: ROXL   420 ISR ;    : ROXR   020 ISR ;
: ROL    430 ISR ;    : ROR    030 ISR ;
: IBIT   ( sea dea instr -- )   >R EXTRA? EAS R> OR SWAP DN?
   IF RD OR 400 OR ,W
   ELSE SWAP 4000 OR ,W IMM?DROP LOW ,W ENDIF
   ,EXTRA ;
: BTST   000 IBIT ;
: BCHG   100 IBIT ;
: BCLR   200 IBIT ;
: BSET   300 IBIT ;

( ------ BRANCHS, LOOPS, AND SET CONDITIONAL --------- )
: IBRA   10 SHL 060000 OR
   SWAP HERE 2+ - DUP ABS 200 <
   IF LOW OR ,W ELSE SWAP ,W ,W ENDIF ;
: BRA 00 IBRA ; : BSR 01 IBRA ; : BHI 02 IBRA ; : BLS 03 IBRA ;
: BCC 04 IBRA ; : BCS 05 IBRA ; : BNE 06 IBRA ; : BEQ 07 IBRA ;
: BVC 10 IBRA ; : BVS 11 IBRA ; : BPL 12 IBRA ; : BMI 13 IBRA ;
: BGE 14 IBRA ; : BLT 15 IBRA ; : BGT 16 IBRA ; : BLE 17 IBRA ;
: IDBR  10 SHL 050310 OR
   ROT RS OR ,W HERE - ,W ;
: DBT  00 IDBR ; : DBF  01 IDBR ; : DBRA 01 IDBR ;
: DBHI 02 IDBR ; : DBLS 03 IDBR ;
: DBCC 04 IDBR ; : DBCS 05 IDBR ;
: DBNE 06 IDBR ; : DBEQ 07 IDBR ;
: DBVC 10 IDBR ; : DBVS 11 IDBR ;
: DBPL 12 IDBR ; : DBMI 13 IDBR ;
: DBGE 14 IDBR ; : DBLT 15 IDBR ;
: DBGT 16 IDBR ; : DBLE 17 IDBR ;
: ISET   10 SHL 050300 OR SRC ,W ,MORE ;
: ST  00 ISET ; : SF  01 ISET ; : SHI 02 ISET ; : SLS 03 ISET ;
: SCC 04 ISET ; : SCS 05 ISET ; : SNE 06 ISET ; : SEQ 07 ISET ;
: SVC 10 ISET ; : SVS 11 ISET ; : SPL 12 ISET ; : SMI 13 ISET ;
: SGE 14 ISET ; : SLT 15 ISET ; : SGT 16 ISET ; : SLE 17 ISET ;
                                                               
( ---------------------- MOVE -------------------------)
: MOVE      EXTRA? 7700 AND SRC SZ300 ,W ,MORE ,EXTRA ;
: MOVEQ     >R IMM?DROP LOW R> RD OR 070000 OR ,W ;
: MOVE>USP  RS 047140 OR ,W ;
: MOVE<USP  RS 047150 OR ,W ;
: MOVEM>
   EXTRA? EAS 044200 OR -SZ1 ,W IMM?DROP ,W ,EXTRA ;
: MOVEM<
   EXTRA? EAS 046200 OR -SZ1 ,W IMM?DROP ,W ,EXTRA ;
: MOVEP     DN? IF >R EXTRA? RS R> RD OR 410 OR
                ELSE EXTRA? RS SWAP RD OR 610 OR ENDIF
            -SZ1 ,W ,EXTRA ;
: LMOVE     7700 AND SWAP EAS OR 20000 OR ,W ;


( ----------- ODDS AND ENDS --------------- )
: CMP    130000 DST SRC SZ3 ,W ,MORE ;
: CMPM   RD SWAP RS OR 130410 OR SZ3 ,W ;
: EOR    EXTRA? EAS DST SZ3 130400 OR ,W ,EXTRA ;
: EXG    DN? IF SWAP DN? IF 140500 ELSE 140610 ENDIF >R
             ELSE SWAP DN? IF 140610 ELSE 140510  ENDIF >R SWAP
             ENDIF RS DST R> OR ,W ;
: EXT    RS 044200 OR -SZ1 ,W ;
: LINK   IMM?DROP >R RS 047120 OR ,W R> ,W ;
: STOP   47162 ,W IMM?DROP ,W ;
: SWAP   RS 044100 OR ,W ;
: TRAP   IMM?DROP 17 AND 47100 OR ,W ;
: UNLK   RS 047130 OR ,W ;

( ------------- ARITHMETIC AND LOGIC ------------------ )     
: IBCDD   ( sea dea instr -- instr )
   DST OVER RS OR [ FORTH ] SWAP [ ASSEMBLER ] MS IF 10 OR ENDIF ;
: ABCD   140400 IBCDD ,W ;        : SBCD   100400 IBCDD ,W ;
: ADDX   150400 IBCDD SZ3 ,W ;    : SUBX   110400 IBCDD SZ3 ,W ;
: IDEA   ( sea dea instr -- )   >R DN?
   IF RD SRC R> OR SZ3 ,W ,MORE
   ELSE EXTRA? EAS DST 400 OR R> OR SZ3 ,W ,EXTRA ENDIF ;
: ADD   150000 IDEA ;
: SUB   110000 IDEA ;
: AND   140000 IDEA ;
: OR    100000 IDEA ;
: IEAD   ( sea dea instr -- )   DST SRC ,W ,MORE ;
: CHK    040600 IEAD ;
: DIVU   100300 IEAD ;    : DIVS   100700 IEAD ;
: MULU   140300 IEAD ;    : MULS   140700 IEAD ;

( ------------ ARITHMETIC AND CONTROL ---------------- )
: IEA   ( ea instr -- )   SRC ,W ,MORE ;
: JSR        047200 IEA ;
: JMP        047300 IEA ;
: MOVE>CCR   042300 IEA ;
: MOVE<SR    040300 IEA ;
: MOVE>SR    043300 IEA ;
: NBCD       044000 IEA ;
: PEA        044100 IEA ;
: TAS        045300 IEA ;
: IEAS   ( ea instr -- )   SRC SZ3 ,W ,MORE ;
: CLR    041000 IEAS ;
: NOT    043000 IEAS ;
: NEG    042000 IEAS ;
: NEGX   040000 IEAS ;
: TST    045000 IEAS ;
: NOP     047161 ,W ;
: RESET   047160 ,W ;
: RTE     047163 ,W ;
: RTS     047165 ,W ;

( -------------- STRUCTURED CONDITIONALS -------------- )
: ENDIF   HERE OVER 2+ - [ FORTH ] SWAP [ ASSEMBLER ] 1+ !B ;
: IF      ,W HERE 2- ;  HEX
: ELSE    6000 IF [ FORTH ] SWAP [ ASSEMBLER ] ENDIF ;
: BEGIN   HERE ;
: UNTIL   ,W HERE - HERE 1- !B ;
: AGAIN   6000 UNTIL ;
: WHILE   IF ;
: REPEAT  [ FORTH ] SWAP [ ASSEMBLER ] AGAIN ENDIF ;
: DO      TUCK # [ FORTH ] SWAP [ ASSEMBLER ] LONG MOVE HERE ;
: LOOP    DBRA ;
6600 CONSTANT 0=   6700 CONSTANT 0<>
6A00 CONSTANT 0<   6B00 CONSTANT 0>=
6C00 CONSTANT <    6D00 CONSTANT >=
6E00 CONSTANT <=   6F00 CONSTANT >

DECIMAL 
FORTH DEFINITIONS 
QUIT


